/* CTYPE.C: Charter expersions */

/* Sevral Ideas for code from Dr. Dobbs Z80 Toolbook */

/* This function sets up a is* function for initalization! Expands to:
 * ld   hl, 2
 * add  hl, sp
 * ld   a, (hl)
 * ld   h, 0
 * ld   l, h
 */
#define SetupIs              asm("\tld\thl,2\n\tadd\thl, sp\n\tld\ta, (hl)\n\tld\th, 0\n\tld\tl, h\n");

/*
 * CheckGroup(expr, min, max) macro expands to
 * _expr:
 * cp   'min'
 * ret  c
 * cp   'max'+1
 * ret  nc
 * inc  l
 */
#define CheckGroup(expr, min, max) asm("_" #expr ":\n\tcp\t'" #min "'\n\tret\tc\n\tcp\t'" #max "'+1\n\tret\tnc\n\tinc\tl\n");

/* Check for charaters (A-Z, a-z, 0-9) */
isalnum(c) char c;
{
    SetupIs;
#asm
    call _islower
    call _isupper
    call _isdigit
#endasm
}

/* Check for charaters (A-Z, a-z) */
isalpha(c) char c;{
    SetupIs;
#asm
    call _islower
    call _isupper
#endasm
	}

/* Check for uppercase letters */
isupper(c) char c;{
    SetupIs;
    CheckGroup(isupper, A,Z);
	}

islower(c) char c;{
    SetupIs;
    CheckGroup(islower, a,z);
	}

isdigit(c) char c;{
    SetupIs;
    CheckGroup(isdigit, 0,9);
	}

isspace(c) char c;{
#asm
    ld  hl, 2
    add hl, sp
    ld  a, (hl)
    ld  hl, 1                   ; Defualt to true

    cp  9                       ; Tab check
    ret z

    cp  10                      ; Newline check
    ret z

    cp  ' '                     ; Space check
    ret z
    
    dec hl
#endasm
	}

toupper(c) char c;{
#asm
    ld  hl, 2
    add hl, sp
    ld  a, (hl)
    ld  h, 0
    ld  l, a

    cp  'a'
    ret c
    cp  'z'+1
    ret nc

    sub 32

    ld l,a
#endasm
	}

tolower(c) char c;{
#asm
    ld  hl, 2
    add hl, sp
    ld  a, (hl)
    ld  h, 0
    ld  l, a

    cp  'A'
    ret c
    cp  'Z'+1
    ret nc

    add A, 32

    ld  l,a
#endasm
	}
