#ifndef __LINE_C
#define __LINE_C

#ifndef __PIXEL_C_
#include <pixel.c>
#endif

/*
   Small c library, by Chris Dannemiller (dannemiller@hotmail.com)
   http://www.geocities.com/SiliconValley/Vista/1143

   Synopsis:
      line(x1,y1,x2,y2,c)

   Description:
      This fuction draws a line form (x1,y1)-(x2,y2). Most of the code was
      taken for Small C for the TI-85 Alothough I fixed a bug in this code.
      You also have to specify the color mode you will be drawing in.

   Example:
      line(5,5,20,30,PT_ON)
      line(6,7,32,22,PT_CHG)

   Notes:
      o See ti.h for desciption of the PT_* macros

*/

char _lnway;
char _color;

line (x1,y1,x2,y2,c) char x1,y1,x2,y2,c; {
#asm
   ; Grab arguments off stack
        ld      hl,2
        add     hl,sp
        ld      a,(hl)
        ld      (_color),a
        inc     hl
        inc     hl
        ld      d,(hl)
        inc     hl
        inc     hl
        ld      e,(hl)
        inc     hl
        inc     hl
        ld      c,(hl)
        inc     hl
        inc     hl
        ld      l,(hl)
        ld      h,c

        ld      a,d
        sub     h
        jr      NC,_lndxpos     ;delta_x > 0
_lndxneg:
        neg  
_lndxpos:
        ld      B,A             ;B <- |delta_x|
        ld      A,E            
        sub     L               
        jr      NC,_lndypos     ;delta_y > 0
_lndyneg:
        neg
_lndypos:
        sub     B               ;|delta_y|
        push    AF
        jr      C,_lndx         ;|delta_x| > |delta_y|
_lndy:
        ld      A,H             ;if |delta_x| < |delta_y| then
        ld      H,L             ;then values x and y are swapped
        ld      L,A             ;so the loop will always be performed on the
        ld      A,D             ;x value. A flag must be set to
        ld      D,E             ;remind that data must be drawn (y,x)
        ld      E,A             ;instead of (x,y)

        ;ld      A,$01
        ;ld      (Flag),A        ;the Flag !!!
_lndx:
        ld      A,D
        sub     H
        jr      NC,_lntdy        ;x1 < x2
_lntdx:
        ex	DE,HL
_lntdy:
        inc     d
        ld      A,E
        sub     L
        ld      A,$01
        jr      NC,_lnsta
        neg                     ;y1 > y2 : in _lncase2 the 'y' variable
_lnsta:
        ld      (_lnway),A
_lninitl:
        ld      B,H
        ld      C,L
        ld      A,E
        sub     L
        jr      NC,_lneinit
        ld      A,L
        ld      L,E
        ld      E,A
_lneinit:
        ld      A,E
        sub     L
        rla
        ld      L,A             ;value to add in _lncase1 (d < 0)
        add     A,H
        sub     D
        ld      E,A             ;'d' variable is initialised
        add     A,H
        sub     D
        ld      H,A             ;value to add in _lncase2 (d >= 0)
_lnloop:
        ld      A,B
        sub     D
        jr      NC,_lnend       ;the line is completely drawn.
        pop     AF
        ;ld      A,(Flag)
        bit     7,A
        push    AF
        push    AF
        push    BC
        jr      Z,_lndpt
        ld      A,B
        ld      B,C
        ld      C,A
_lndpt:
        push    de
        push    hl
        ld      a,(_color)
        ld      d, c
        ld      e, b
        call    _drawpix
        pop     hl
        pop     de
        pop     BC
        pop     AF
;TestD:
        bit     7,E
        jr      NZ,_lncase1
_lncase2:                          ;d >= 0 
        ld      A,E
        add     A,H
        ld      E,A
        ld      A,(_lnway)
        add     A,C
        ld      C,A
        jr      _lneloop
_lncase1:                          ;d < 0
        ld      A,E
        add     A,L
        ld      E,A
_lneloop:
        inc     B
        jr      _lnloop
_lnend:
        pop     AF              ;MUST NOT BE REMOVED
#endasm
}


#endif 
